Subject: bug#74833: 31.0.50; Copy to OS clipboard doesn't work in macOS Terminal.app with xterm-mouse-mode enabled

From: Ship Mints <[email-masked]>
Date: Fri, 13 Dec 2024 11:52:37 -0500

Try experimenting with alternative terminals such as
https://wezfurlong.org/wezterm/ which I've used and where I remap all of
the keys to pass through to Emacs vs. letting the terminal application
abscond with functions like Command-C. I can share my wezterm configuration
off line if you're interested. I still remain mostly GUI on macOS but
occasionally use the terminal, and especially useful for running Emacs via
ssh on a remote computer (vs. tramp).

On Fri, Dec 13, 2024 at 11:42 AM Ship Mints <[email-masked]> wrote:

> What you describe is normal behavior, even if it appears confusing. It's
> an "impedance mismatch" between terminal.app and being in a "curses"
> window. Terminal doesn't "see" selected text and hence Command-C is
> disabled. This is the opposite for a basic shell where terminal sees the
> text because it controls selection. You can see this by pulling down the
> Edit menu and seeing Copy grayed out. As far as how xterm-mouse-mode
> interferes with Command-C I'd have to disable it myself and see what's
> going on. Not sure how much value that adds, though. If you enable xclip,
> you'll get what you want being inside Emacs, after all, using M-w gets your
> selected text copied to the pasteboard.
>
> On Fri, Dec 13, 2024 at 11:35 AM Filipp Gunbin <[email-masked]>
> wrote:
>
>> On 13/12/2024 09:21 +0200, Eli Zaretskii wrote:
>>
>> >> From: Ship Mints <[email-masked]>
>> >> Date: Thu, 12 Dec 2024 15:31:00 -0500
>> >> Cc: [email-masked], [email-masked]
>> >>
>> >> I have xterm-mouse-mode enabled when in tty mode on macOS and it does
>> work for clicking/selecting but
>> >> this is independent of integrating the kill ring with the pasteboard.
>> I am unaware of how to test the
>> >> completeness of the xterm mouse protocol support, however.
>> >
>> > So why is this an Emacs bug?  It sounds like the OP expects something
>> > to happen which shouldn't, because the xterm protocol for selections
>> > and the clipboard are not supported by Terminal.app?  In that case,
>> > this could be at best a feature request, not a bug.
>>
>> I'll try to explain differently.
>>
>> Without xterm-mouse-mode you can copy/paste from/into Terminal.app
>> window, looks like Terminal.app gives this ability on its own.  This is
>> not integration with Emacs kill ring, no.  Emacs cursor does not react
>> to mouse clicks, and selection happens with OS mouse pointer.  Paste
>> works rather slow (bad idea to paste large chunks of text), but
>> tolerable.
>>
>> Now, yesterday my daily master build got me xterm-mouse-mode enabled, so
>> I did some testing just out of curiosity.  Most of the things work,
>> including clicking and selection.  However, Command-C now just doesn't
>> copy text to OS clipboard.  And it's non-obvious that you should disable
>> xterm-mouse-mode to be able to copy.
>>
>> That's why I filed this bug - because previous behavior was not ideal
>> but working, and now only paste works.
>>
>> Maybe we should just avoid enabling xterm-mouse-mode in Terminal.app.
>> Maybe functionality of xclip should be in core.
>>
>